/*
 * 쐬: 2007/11/30
 * 쌠: Copyright (c) 2007 kry
 * CZXFEclipse Public License - v 1.0
 * Fhttp://www.eclipse.org/legal/epl-v10.html
 */
package kry.sql.constant;

/**
 * @author kry
 *
 */
public interface ISQLServerConstant extends IANSISqlConstant {

	public static final String[] RESERVED_WORDS = { "ABSOLUTE", "ACTION",
			"ADA", "ADD", "ADMIN", "AFTER", "AGGREGATE", "ALIAS", "ALL",
			"ALLOCATE", "ALTER", "AND", "ANY", "ARE", "ARRAY", "AS", "ASC",
			"ASSERTION", "AT", "AUTHORIZATION", "AVG", "BACKUP", "BEFORE",
			"BEGIN", "BETWEEN", "BINARY", "BIT", "BIT_LENGTH", "BLOB",
			"BOOLEAN", "BOTH", "BREADTH", "BREAK", "BROWSE", "BULK", "BY",
			"BY", "CALL", "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG",
			"CHAR", "CHAR_LENGTH", "CHARACTER", "CHARACTER_LENGTH", "CHECK",
			"CHECKPOINT", "CLASS", "CLOB", "CLOSE", "CLUSTERED", "COALESCE",
			"COLLATE", "COLLATION", "COLUMN", "COMMIT", "COMPLETION",
			"COMPUTE", "CONNECT", "CONNECTION", "CONSTRAINT", "CONSTRAINTS",
			"CONSTRUCTOR", "CONTAINS", "CONTAINSTABLE", "CONTINUE", "CONVERT",
			"CORRESPONDING", "COUNT", "CREATE", "CROSS", "CROSS", "CUBE",
			"CURRENT", "CURRENT_DATE", "CURRENT_PATH", "CURRENT_ROLE",
			"CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR",
			"CYCLE", "DATA", "DATABASE", "DATE", "DAY", "DAY", "DBCC",
			"DEALLOCATE", "DEC", "DEC", "DECIMAL", "DECLARE", "DEFAULT",
			"DEFERRABLE", "DEFERRED", "DELETE", "DENY", "DEPTH", "DEREF",
			"DESC", "DESCRIBE", "DESCRIPTOR", "DESTROY", "DESTRUCTOR",
			"DETERMINISTIC", "DIAGNOSTICS", "DICTIONARY", "DISCONNECT", "DISK",
			"DISTINCT", "DISTRIBUTED", "DOMAIN", "DOUBLE", "DROP", "DUMP",
			"DYNAMIC", "EACH", "ELSE", "END", "END-EXEC", "EQUALS", "ERRLVL",
			"ESCAPE", "EVERY", "EXCEPT", "EXCEPTION", "EXEC", "EXECUTE",
			"EXISTS", "EXIT", "EXTERNAL", "EXTRACT", "FALSE", "FETCH", "FILE",
			"FILLFACTOR", "FIRST", "FLOAT", "FOR", "FOREIGN", "FORTRAN",
			"FOUND", "FREE", "FREETEXT", "FREETEXTTABLE", "FROM", "FULL",
			"FULLTEXTTABLE", "FUNCTION", "GENERAL", "GET", "GLOBAL", "GO",
			"GOTO", "GRANT", "GROUP", "GROUPING", "HAVING", "HOLDLOCK", "HOST",
			"HOUR", "IDENTITY", "IDENTITY_INSERT", "IDENTITYCOL", "IF",
			"IGNORE", "IMMEDIATE", "IN", "IN", "INCLUDE", "INDEX", "INDICATOR",
			"INITIALIZE", "INITIALLY", "INNER", "INOUT", "INPUT",
			"INSENSITIVE", "INSERT", "INT", "INTEGER", "INTERSECT", "INTERVAL",
			"INTO", "IS", "ISOLATION", "ITERATE", "JOIN", "KEY", "KILL",
			"LANGUAGE", "LARGE", "LAST", "LATERAL", "LEADING", "LEFT", "LESS",
			"LEVEL", "LIKE", "LIMIT", "LINENO", "LOAD", "LOCAL", "LOCALTIME",
			"LOCALTIMESTAMP", "LOCATOR", "LOWER", "MAP", "MATCH", "MAX", "MIN",
			"MINUTE", "MODIFIES", "MODIFY", "MODULE", "MONTH", "NAMES",
			"NATIONAL", "NATURAL", "NCHAR", "NCLOB", "NEW", "NEXT", "NO", "NO",
			"NOCHECK", "NONCLUSTERED", "NONE", "NOT", "NULL", "NULLIF",
			"NUMERIC", "OBJECT", "OCTET_LENGTH", "OF", "OFF", "OFFSETS", "OLD",
			"ON", "ONLY", "OPEN", "OPENDATASOURCE", "OPENQUERY", "OPENROWSET",
			"OPENXML", "OPERATION", "OPTION", "OR", "ORDER", "ORDINALITY",
			"OUT", "OUTER", "OUTPUT", "OVER", "OVERLAPS", "PAD", "PARAMETER",
			"PARAMETERS", "PARTIAL", "PASCAL", "PATH", "PERCENT", "PIVOT",
			"PLAN", "POSITION", "POSTFIX", "PRECISION", "PREFIX", "PREORDER",
			"PREPARE", "PRESERVE", "PRIMARY", "PRINT", "PRIOR", "PRIVILEGES",
			"PROC", "PROCEDURE", "PUBLIC", "RAISERROR", "READ", "READS",
			"READTEXT", "REAL", "RECONFIGURE", "RECURSIVE", "REF",
			"REFERENCES", "REFERENCING", "RELATIVE", "REPLICATION", "RESTORE",
			"RESTRICT", "RESULT", "RETURN", "RETURNS", "REVERT", "REVOKE",
			"RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROUTINE", "ROW",
			"ROWCOUNT", "ROWGUIDCOL", "ROWS", "RULE", "SAVE", "SAVEPOINT",
			"SCHEMA", "SCOPE", "SCROLL", "SEARCH", "SECOND", "SECTION",
			"SECURITYAUDIT", "SELECT", "SEQUENCE", "SESSION", "SESSION_USER",
			"SET", "SETS", "SETUSER", "SHUTDOWN", "SIZE", "SMALLINT", "SOME",
			"SPACE", "SPECIFIC", "SPECIFICTYPE", "SQL", "SQLCA", "SQLCODE",
			"SQLERROR", "SQLEXCEPTION", "SQLSTATE", "SQLWARNING", "START",
			"STATE", "STATEMENT", "STATIC", "STATISTICS", "STRUCTURE",
			"SUBSTRING", "SUM", "SYSTEM_USER", "TABLE", "TABLESAMPLE",
			"TEMPORARY", "TERMINATE", "TEXTSIZE", "THAN", "THEN", "TIME",
			"TIMESTAMP", "TIMEZONE_HOUR", "TIMEZONE_MINUTE", "TO", "TOP",
			"TRAILING", "TRAN", "TRANSACTION", "TRANSLATE", "TRANSLATION",
			"TREAT", "TRIGGER", "TRIM", "TRUE", "TRUNCATE", "TSEQUAL", "UNDER",
			"UNION", "UNIQUE", "UNKNOWN", "UNNEST", "UNPIVOT", "UPDATE",
			"UPDATETEXT", "UPPER", "USAGE", "USE", "USER", "USING", "VALUE",
			"VALUES", "VARCHAR", "VARIABLE", "VARYING", "VIEW", "WAITFOR",
			"WHEN", "WHENEVER", "WHERE", "WHILE", "WITH", "WITHOUT", "WORK",
			"WRITE", "WRITETEXT", "YEAR", "ZONE" };
}
